﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Data;
using C1.Silverlight.DataGrid;
using System.Reflection;

namespace SL_DataGrid_ComboInSpecificCells
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            NameList nm = new NameList();

            c1grid1.ItemsSource = nm;

            DataGridComboTextColumn mc = new DataGridComboTextColumn();
            mc.IsReadOnly = false;
            mc.Header = "Custom Column";
            Binding bnd = new Binding();
            bnd.Path = new PropertyPath("CountryName");
            bnd.Mode = BindingMode.TwoWay;
            mc.Binding = bnd;

            c1grid1.Columns.Add(mc);

        }
    }

    public class DataGridComboTextColumn : DataGridTextColumn
    {
        List<string> cntryList = new List<string>();
        public DataGridComboTextColumn()
            : base()
        {
            cntryList.Add("India");
            cntryList.Add("US");
            cntryList.Add("UK");
            cntryList.Add("Japan");
            cntryList.Add("China");
        }

        public override FrameworkElement GetCellEditingContent(DataGridRow row)
        {
            if (row.Index % 2 == 0)
            {
                var cmb = new C1.Silverlight.C1ComboBox() { ItemsSource = cntryList, Text= (row.DataItem as PersonName).CountryName };
                cmb.IsEditable = true;
                cmb.Padding = new Thickness(0);
                cmb.EditCompleted += cmb_EditCompleted;
                cmb.Tag = (int)row.Index;
   
                return cmb;
            }

            return new TextBox() { Text = (row.DataItem as PersonName).CountryName };
        }
               
        void cmb_EditCompleted(object sender, EventArgs e)
        {            
            string editingvalue = (sender as C1.Silverlight.C1ComboBox).Text;
            if (editingvalue != string.Empty)
                if (!cntryList.Contains(editingvalue))
                    cntryList.Add(editingvalue);
            int rowIndex=(int)(sender as C1.Silverlight.C1ComboBox).Tag;
            (this.DataGrid.Rows[rowIndex].DataItem as PersonName).CountryName = editingvalue;
            this.DataGrid.Rows[rowIndex].Refresh(false, true, false);
        }

        public override object PrepareCellForEdit(FrameworkElement editingElement)
        {
            if (editingElement.GetType().Equals(typeof(C1.Silverlight.C1ComboBox)))
            {
                string editingValue = ((SL_DataGrid_ComboInSpecificCells.PersonName)((editingElement as C1.Silverlight.C1ComboBox).DataContext)).CountryName;

                (editingElement as C1.Silverlight.C1ComboBox).SelectedIndex = cntryList.IndexOf(editingValue);
            }
            return editingElement;
        }
    }

    public class NameList : ObservableCollection<PersonName>
    {
        public NameList()
            : base()
        {
            Add(new PersonName("Willa", "US"));
            Add(new PersonName("Isak", "UK"));
            Add(new PersonName("Victor", "India"));
            Add(new PersonName("Jules", "Japan"));
        }
    }

    public class PersonName
    {
        private string firstName;
        private string country;

        public PersonName(string first, string cntry)
        {
            this.firstName = first;
            this.country = cntry;
        }

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }

        public string CountryName
        {
            get { return country; }
            set { country = value; }
        }
    }

}
